#include <stdio.h>
#include <signal.h> 
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef __CYGWIN__
#ifndef linux
#define linux
#endif
#endif

#ifdef linux
#include <sys/time.h>
#endif

#ifndef WIN32
#include <unistd.h>
#endif

#ifdef linux
#ifdef _K5_USE_FOPEN64_
#define fopen(_Z,_X) fopen64(_Z,_X)
#endif
#ifdef _LARGEFILE_SOURCE               
#define fseek(_Z,_X,_W) fseeko(_Z,_X,_W)
#define ftell(_Z) ftello(_Z)
#endif
#endif


/* for WIN32 */

#ifdef WIN32
#pragma warning (disable:4996)
#ifndef _FORWIN32SET_
#define _FORWIN32SET_
typedef unsigned int    u_int32_t;
typedef unsigned int    uint32_t;
typedef unsigned short int    u_int16_t;
typedef unsigned short int    uint16_t;
typedef unsigned char   u_int8_t;
typedef _int64 int64_t;
//typedef long long int int64_t;                   // thi is also OK for WIN 32 2015-11-04
#define popen(_Z,_X) _popen(_Z,_X)
#define fseek(_Z,_X,_W) _fseeki64(_Z,_X,_W)      // added on 2014-06-03
#define pclose(_Z) _pclose(_Z)
#define ftell(_Z) _ftelli64(_Z)                  // added on 2014-06-03
#endif
#endif

typedef struct m5b_recov
{
    char m5bname[256];  // Mark5B file name to be edited
    char outfile[256];  // File name after edited
    int istart[6];      // time at 1st frame 
                        //  -1,mjd(3digits),hh,mm,ss,msec*10  (like a VLBA format)
    int istop[6];       // time at last frame 
	double fbps;      // for Mark5B
	int iuid,tvgflag; // for Mark5B
    int framsec; // frames/sec
	int badframes; 
	int totalframes;
	int framstart;
    double tframe,dlength;
    int64_t fsize;
} m5b_recov_t;



int mk5b_dat_anal_edit(m5b_recov_t *m5b);
int mk5b_sync(int *head, int *itime, int *seconds, unsigned short int *uid,
					  int *tvgflag, int *nframe, unsigned short int *icrc16);

void conv2time_m5b(int *idat, int *itime, int *mjd3, int *seconds);
void convmjsdsec_word(int mjd3, int seconds, int *iword);
void m5b_hd_crcc_setup(int *head);
int64_t get_file_size(char *fname);
int crcc(unsigned char* idata, int len, int mask, int cycl);
int64_t get_file_size(char *fname);
int rvsint(int i4);

